MKTHNUM - K-th Number

You are working for Macrohard company in data structures department. After failing your previous task about key insertion you were asked to write a new data structure that would be able to return quickly k-th order statistics in the array segment.

That is, given an array a[1 ... n] of different integer numbers, your program must answer a series of questions Q(i, j, k) in the form: "What would be the k-th number in a[i ... j] segment, if this segment was sorted?"

For example, consider the array a = (1, 5, 2, 6, 3, 7, 4). Let the question be Q(2, 5, 3). The segment a[2 ... 5] is (5, 2, 6, 3). If we sort this segment, we get (2, 3, 5, 6), the third number is 5, and therefore the answer to the question is 5.

Input

The first line of the input contains n — the size of the array, and m — the number of questions to answer (1 ≤ n ≤ 100000, 1 ≤ m ≤ 5000).

The second line contains n different integer numbers not exceeding 10^9 by their absolute values — the array for which the answers should be given.

The following m lines contain question descriptions, each description consists of three numbers: i, j, and k (1 ≤ i ≤ j ≤ n, 1 ≤ k ≤ j - i + 1) and represents the question Q(i, j, k).

Output

For each question output the answer to it — the k-th number in sorted a[i ... j] segment.

Example

Input:
7 3
1 5 2 6 3 7 4
2 5 3
4 4 1
1 7 3

Output:
5
6
3

Note: a naive solution will not work!!!


Added by:psetter
Date:2009-02-24
Time limit:1s
Source limit:50000B
Memory limit:1536MB
Cluster: Cube (Intel G860)
Languages:All except: ERL JS-RHINO
Resource:Northeastern Europe 2004 Northern Subregion

hide comments
2022-08-17 13:01:11 Mayundo Mwenze
Can't be solved in Python.
2022-04-05 13:11:01
Why the time limit is 1 second and my solutions runs in 1.85 and I got AC?
I used Merge sort Tree.
2022-02-15 17:07:51
Solved using Mo's algorithm in O(n * sqrt(n) * log^2(n))
0.9 second used
2022-02-08 00:04:27
n different integer numbers not exceeding 10^9 by their "absolute" values.
So keep an eye on the negative numbers.
2021-11-06 10:00:13
persistent segment tree
2021-06-22 18:42:29
!!WARNING!!
Merge Sort Tree + bs with time O([logn]^2) for each query gives TLE In Java
But C++ works fine

Last edit: 2021-06-22 18:42:53
2021-01-18 22:37:18
My java code got accepted at first submission. Just merge sort tree + Binary search worked though it took over 7 seconds!
2020-11-24 12:37:39
Note : for java users Merge Sort Tree + BinarySearch Will give u tle on 16th Test case .

C++ same algo will work.

:(
2020-10-15 01:31:42
Thanks for setting a Java-friendly time limit.
2020-10-14 15:14:27
No need for coordinade compression like some people are saying, binary searching the entire range works fine.
© Spoj.com. All Rights Reserved. Spoj uses Sphere Engine™ © by Sphere Research Labs.